  MEMBER

  MAP
    MODULE('windows')
        Sleep(LONG dwMilliseconds=0),PASCAL
    END
  END

  INCLUDE('CWSYNCHM.INC'),ONCE
  INCLUDE('CWSYNCHC.INC'),ONCE
  INCLUDE('CBCSGlobal.INC'),ONCE

PublicCS          CriticalSection     !Critical Section Used for Public Use by CBCSGlobalClass
SafeCS            CriticalSection     !Used for SafeNewCriticalSection and SafeDisposeCriticalSection
                                      !decided to make a special CS just for this to insure no chance of lock ups
!========================================================================================================
CBCSGlobalClass.Wait                PROCEDURE()
    CODE
    PublicCS.Wait()
    RETURN
!========================================================================================================
CBCSGlobalClass.Release             PROCEDURE()
    CODE
    PublicCS.Release()
    RETURN
!========================================================================================================
CBCSGlobalClass.GetIFace            PROCEDURE()!,*ISyncObject
    CODE
    RETURN PublicCS.GetIFace()

!========================================================================================================
! Create a new CS with a SafeCS locked so no other Thread could be trying to also do a NewCS
! Call as  MyCS &= CSGLobal.SafeNewCriticalSection(MyCS)
CBCSGlobalClass.SafeNewCriticalSection     PROCEDURE(*ICriticalSection In_ICriticalSection)!,*ICriticalSection
CritProc    CriticalProcedure
    CODE
    CritProc.Init(SafeCS.GetIFace())                    !Locked so nobody else can be in here or SafeDispose
    IF In_ICriticalSection &= NULL                      !The CS Does NOT exist
       In_ICriticalSection &= NewCriticalSection()      !Make a new one to return
    END
    Sleep(1)                                            !Try to insure we get an entire time slice so the returned *ICrit can be assigned before another thread wants to use it
    RETURN In_ICriticalSection                          !Got to return it becuase Clarion cannot have In/Out Class

!========================================================================================================
CBCSGlobalClass.SafeDisposeCriticalSection     PROCEDURE(*ICriticalSection In_ICriticalSection)!,*ICriticalSection
CritProc    CriticalProcedure
    CODE
    CritProc.Init(SafeCS.GetIFace())                     !Locked so nobody else can be in here or SafeNew
    IF ~In_ICriticalSection &= NULL                      !The CS Does NOT exist
        In_ICriticalSection.Wait                         !Make sure we can own it to insure nobody has it locked, caller shouldn't ever kill a CS unless it is certain it is no longer used
        In_ICriticalSection.Release                      !Should'nt mater if I kill it owned but ....
        In_ICriticalSection.Kill
        In_ICriticalSection &= Null
    END
    Sleep(1)
    RETURN In_ICriticalSection                           !Got to return it because Clarion cannot have In/Out *Class


!!========================================================================================================
!CBCSGlobalClass.SafeNewICriticalSection  PROCEDURE(*ICriticalSection InOut_ICriticalSection)!,BYTE,PROC    !Returns 0=Ok, 1=Already Exists 2=Failed
!CritProc    CriticalProcedure
!RetByte     BYTE,AUTO
!    CODE
!    CritProc.Init(SafeCS.GetIFace())                    !Locked so nobody else can be in here
!    IF InOut_ICriticalSection &= NULL                   !The CS Does NOT exist
!       InOut_ICriticalSection &= NewCriticalSection()   ! So make a New One
!       IF ~InOut_ICriticalSection &= Null               ! Verify that we did in fact get it
!          RetBYTE = 0                                   !   Tell the caller 0=Success
!       ELSE                                             ! We failed to get it
!?         ASSERT(0,'SafeNewICriticalSection failed NewCriticalSection')
!          RetBYTE = 2                                   !   Tell the caller 2=Failed badly
!       END
!    ELSE                                                !the CS already exists, do nothing, somebody beat us here
!       RetByte = 1                                      !   Tell the caller 1=It weas already made
!    END
!    RETURN RetBYTE
!!========================================================================================================
!CBCSGlobalClass.SafeDisposeICriticalSection  PROCEDURE(*ICriticalSection InOut_ICriticalSection)!,BYTE,PROC   !Returns 0=Ok, 1=Didn't Exist 2=Failed
!CritProc    CriticalProcedure
!RetByte     BYTE,AUTO
!    CODE
!    CritProc.Init(SafeCS.GetIFace())                    !Locked so nobody else can be in here
!    IF ~InOut_ICriticalSection &= NULL                  !The CS DOES exist
!       InOut_ICriticalSection.Kill()                    ! So Kill it
!       InOut_ICriticalSection &= NULL                   ! and null the pointer 
!       IF InOut_ICriticalSection &= Null                ! Verify that we did in fact get rid of it
!          RetBYTE = 0                                   !   Tell the caller 0=Success
!       ELSE                                             ! We failed to get it
!?         ASSERT(0,'SafeDisposeICriticalSection failed')
!          RetBYTE = 2                                   !   Tell the caller 2=Failed badly
!       END
!    ELSE                                                !the CS was null to start with, do nothing, somebody beat us here
!       RetByte = 1                                      !   Tell the caller 1=It was already killed
!    END
!    RETURN RetBYTE

